import { $index, $route } from './symbols';
export declare type JoinPath<T extends string, U extends string> = U extends 'index' ? T : `${T}/${U}`;
export declare type DynamicRouteKey = `[${string}]`;
export declare type ExtractDynamicRouteKey<T> = Extract<keyof T, DynamicRouteKey>;
export declare type RouteValue = typeof $route | RouteOptions;
export declare type RouteOptions = {
    [K in string]: RouteValue;
};
export declare type MappedRouteValue<R extends typeof $route | RouteOptions, K extends string> = R extends typeof $route ? K extends '' ? '/' : K : R extends RouteOptions ? MappedRouteOptions<R, K> : never;
export declare type HasIndexSymbol<K extends string> = {
    [$index]: K;
};
export declare type MappedRouteOptions<T extends RouteOptions, Prev extends string> = HasIndexSymbol<Prev> & {
    [K in keyof T as K extends DynamicRouteKey ? never : K]: MappedRouteValue<T[K], JoinPath<Prev, K & string>>;
} & (ExtractDynamicRouteKey<T> extends never ? {} : <K extends string | null>(path: K) => MappedRouteValue<T[ExtractDynamicRouteKey<T>], JoinPath<Prev, K extends string ? K : ExtractDynamicRouteKey<T>>>);
